const path = require('path');
const os = require('os');
const fs = require('fs');

// création du dossier documents, verif s'il exite
const documentsDir = path.join(__dirname, 'documents');
if (!fs.existsSync(documentsDir)) {
  fs.mkdirSync(documentsDir);
  console.log("dossier documents créé");
} else {
    console.log("déjà créé");
    
}

// création du fichier rapport.txt, verif au préalable s'il exite
const rapportFile = path.join(documentsDir, 'rapport.txt');
if (!fs.existsSync(rapportFile)) {
  fs.writeFileSync(rapportFile, '');
  console.log("rapport txt créé");
} else{
    console.log("déjà créé")
}

// path.join
const cheminAvecJoin = path.join(os.homedir(), 'documents', 'rapport.txt');
console.log("\ Chemin créé avec path.join:");
console.log(cheminAvecJoin);

// path.resolve
const cheminAbsolu = path.resolve('documents', 'rapport.txt');
console.log("\ path.resolve ");
console.log(cheminAbsolu);

// path.extname
const extension = path.extname(cheminAbsolu);
console.log("\ path.extname");
console.log(extension);
console.log(`fichier txt ? ${extension === '.txt' ? 'oui' : 'non'}`);

// path.dirname
const repertoire = path.dirname(cheminAbsolu);
console.log("\ path.dirname:");
console.log(repertoire);

// path.basename 
const nomFichier = path.basename(cheminAbsolu, path.extname(cheminAbsolu));
console.log("\ Nom du fichier sans extension avec path.basename:");
console.log(nomFichier);

// path.parse
const detailsChemin = path.parse(cheminAbsolu);
console.log("\n6. Détails du chemin avec path.parse:");
console.log(detailsChemin);

// path.normalize
const cheminNonNormalise = path.join('documents', '//', 'sous-dossier', '..', '/rapport.txt');
const cheminNormalise = path.normalize(cheminNonNormalise);
console.log(`non normalisé: ${cheminNonNormalise}`);
console.log(`normalisé: ${cheminNormalise}`);